var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/resources/media-pipelines/index.ts
var media_pipelines_exports = {};
__export(media_pipelines_exports, {
  handler: () => handler
});
module.exports = __toCommonJS(media_pipelines_exports);

// src/resources/media-pipelines/kinesisVideoStreamPool.ts
var import_client_chime_sdk_media_pipelines = require("@aws-sdk/client-chime-sdk-media-pipelines");
var import_client_kinesis_video = require("@aws-sdk/client-kinesis-video");
var import_client_ssm = require("@aws-sdk/client-ssm");
var ssmClient = new import_client_ssm.SSMClient({ region: process.env.AWS_REGION });
var chimeSDKMediaPipelineClient = new import_client_chime_sdk_media_pipelines.ChimeSDKMediaPipelinesClient({
  region: process.env.AWS_REGION
});
var kinesisVideoClient = new import_client_kinesis_video.KinesisVideoClient({
  region: process.env.AWS_REGION
});
var getParameterCommandOutput;
function capitalizeKeys(obj) {
  if (Array.isArray(obj)) {
    return obj.map((item) => capitalizeKeys(item));
  }
  if (typeof obj === "object") {
    const capitalizedObj = {};
    for (const key in obj) {
      if (obj.hasOwnProperty(key)) {
        const capitalizedKey = key.charAt(0).toUpperCase() + key.slice(1);
        const value = obj[key];
        capitalizedObj[capitalizedKey] = typeof value === "string" && !isNaN(parseFloat(value)) ? parseFloat(value) : capitalizeKeys(value);
      }
    }
    return capitalizedObj;
  }
  return obj;
}
var createMediaPipelineKinesisVideoStreamPoolCommandOutput;
var createMediaPipelineKinesisVideoStreamPoolCommandInput;
var formatProps = (props) => {
  let formattedTags = [];
  if (props.tags) {
    console.info(`Formatting Tags: ${JSON.stringify(props.tags)}`);
    props.tags.forEach((tag) => {
      formattedTags.push(capitalizeKeys(tag));
    });
    console.info(`Formatted Tags: ${JSON.stringify(formattedTags)}`);
  }
  console.log(`New formattedTags: ${formattedTags}`);
  createMediaPipelineKinesisVideoStreamPoolCommandInput = {
    PoolName: props.poolName,
    StreamConfiguration: capitalizeKeys(props.streamConfiguration),
    ...props.tags && { Tags: formattedTags },
    ...props.clientRequestToken && {
      ClientRequestToken: props.clientRequestToken
    }
  };
  console.info(
    `mediaInsightsPipelineConfigurationParams: ${JSON.stringify(
      createMediaPipelineKinesisVideoStreamPoolCommandInput
    )}`
  );
  return createMediaPipelineKinesisVideoStreamPoolCommandInput;
};
var CreateKinesisVideoStreamPool = async (uid, props) => {
  console.log(`Creating Kinesis Video Stream Pool: ${uid}`);
  console.log(`CreateKinesisVideoStreamPool props: ${JSON.stringify(props)}`);
  createMediaPipelineKinesisVideoStreamPoolCommandInput = formatProps(props);
  console.log(
    `CreateKinesisVideoStreamPool params: ${JSON.stringify(
      createMediaPipelineKinesisVideoStreamPoolCommandInput
    )}`
  );
  try {
    createMediaPipelineKinesisVideoStreamPoolCommandOutput = await chimeSDKMediaPipelineClient.send(
      new import_client_chime_sdk_media_pipelines.CreateMediaPipelineKinesisVideoStreamPoolCommand(
        createMediaPipelineKinesisVideoStreamPoolCommandInput
      )
    );
    console.log(
      `createMediaInsightsPipelineConfigurationResponse: ${JSON.stringify(
        createMediaPipelineKinesisVideoStreamPoolCommandOutput
      )}`
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  try {
    await ssmClient.send(
      new import_client_ssm.PutParameterCommand({
        Name: "/chime/KinesisVideoStreamPoolId" + uid,
        Value: createMediaPipelineKinesisVideoStreamPoolCommandOutput.KinesisVideoStreamPoolConfiguration?.PoolId,
        Description: "KinesisVideoStreamPoolId" + uid,
        Overwrite: true,
        Type: "String"
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  return createMediaPipelineKinesisVideoStreamPoolCommandOutput.KinesisVideoStreamPoolConfiguration;
};
var updateMediaPipelineKinesisVideoStreamPoolCommandInput;
var updateMediaPipelineKinesisVideoStreamPoolCommandOutput;
var UpdateKinesisVideoStreamPool = async (uid, props) => {
  console.log(`UpdateKinesisVideoStreamPool: ${uid}`);
  console.log(`UpdateKinesisVideoStreamPool props: ${JSON.stringify(props)}`);
  try {
    getParameterCommandOutput = await ssmClient.send(
      new import_client_ssm.GetParameterCommand({
        Name: "/chime/KinesisVideoStreamPoolId" + uid
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  updateMediaPipelineKinesisVideoStreamPoolCommandInput = {
    Identifier: getParameterCommandOutput.Parameter.Value,
    StreamConfiguration: {
      DataRetentionInHours: Number(
        props.streamConfiguration.dataRetentionInHours
      )
    }
  };
  console.log(
    `Update Media Insights Pipeline Configuration params: ${JSON.stringify(
      updateMediaPipelineKinesisVideoStreamPoolCommandInput
    )}`
  );
  try {
    updateMediaPipelineKinesisVideoStreamPoolCommandOutput = await chimeSDKMediaPipelineClient.send(
      new import_client_chime_sdk_media_pipelines.UpdateMediaPipelineKinesisVideoStreamPoolCommand(
        updateMediaPipelineKinesisVideoStreamPoolCommandInput
      )
    );
    console.log(
      `createMediaInsightsPipelineConfigurationResponse: ${JSON.stringify(
        updateMediaPipelineKinesisVideoStreamPoolCommandOutput
      )}`
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  return updateMediaPipelineKinesisVideoStreamPoolCommandOutput.KinesisVideoStreamPoolConfiguration;
};
var DeleteKinesisVideoStreamPool = async (uid, props) => {
  console.log(`DeleteKinesisVideoStreamPool: ${uid}`);
  try {
    getParameterCommandOutput = await ssmClient.send(
      new import_client_ssm.GetParameterCommand({
        Name: "/chime/KinesisVideoStreamPoolId" + uid
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  try {
    await ssmClient.send(
      new import_client_ssm.DeleteParameterCommand({
        Name: "/chime/KinesisVideoStreamPoolId" + uid
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  console.info(`deleteMediaInsightsPipelineIdentifier: ${props.poolName}`);
  try {
    await chimeSDKMediaPipelineClient.send(
      new import_client_chime_sdk_media_pipelines.DeleteMediaPipelineKinesisVideoStreamPoolCommand({
        Identifier: props.poolName
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  await getMediaPipelineKinesisVideoStreamPool(props.poolName, 18);
  const streamsToDelete = await listAllStreams(props.poolName);
  await deleteAllStreams(streamsToDelete);
  return;
};
async function listAllStreams(prefix) {
  let nextToken;
  const streams = [];
  try {
    do {
      const input = {
        MaxResults: 100,
        NextToken: nextToken,
        StreamNameCondition: {
          ComparisonOperator: import_client_kinesis_video.ComparisonOperator.BEGINS_WITH,
          ComparisonValue: "ChimeMediaPipelines-" + prefix
        }
      };
      const response2 = await kinesisVideoClient.send(
        new import_client_kinesis_video.ListStreamsCommand(input)
      );
      if (response2.StreamInfoList) {
        for (const streamInfo of response2.StreamInfoList) {
          if (streamInfo.StreamARN) {
            streams.push(streamInfo.StreamARN);
          }
        }
      }
      nextToken = response2.NextToken;
    } while (nextToken);
  } catch (error) {
    console.error("Error listing streams:", error);
    throw error;
  }
  console.log("Streams to delete: ", streams);
  return streams;
}
async function deleteAllStreams(streamARNs) {
  try {
    for (const streamARN of streamARNs) {
      await kinesisVideoClient.send(
        new import_client_kinesis_video.DeleteStreamCommand({ StreamARN: streamARN })
      );
      console.log("Deleted: ", streamARN);
    }
  } catch (error) {
    console.error("Error listing streams:", error);
    throw error;
  }
  console.log("All streams deleted");
}
async function getMediaPipelineKinesisVideoStreamPool(identifier, maxAttempts) {
  const input = {
    Identifier: identifier
  };
  const command = new import_client_chime_sdk_media_pipelines.GetMediaPipelineKinesisVideoStreamPoolCommand(input);
  for (let attempt = 1; attempt <= maxAttempts; attempt++) {
    try {
      const response2 = await chimeSDKMediaPipelineClient.send(command);
      return response2;
    } catch (error) {
      if (error instanceof Error) {
        const typedError = error;
        if (typedError.name === "ResourceNotFoundException" || typedError.$metadata?.httpStatusCode === 404) {
          console.log(`Resource with identifier ${identifier} not found.`);
          return null;
        } else {
          console.error("Error:", error);
          await sleep(1e4);
        }
      } else {
        console.error("An unexpected error occurred:", error);
        throw error;
      }
    }
  }
  throw new Error(
    `Failed to delete media pipeline after ${maxAttempts} attempts`
  );
}
function sleep(ms) {
  return new Promise((resolve) => setTimeout(resolve, ms));
}

// src/resources/media-pipelines/mediaInsightsPipeline.ts
var import_client_chime_sdk_media_pipelines2 = require("@aws-sdk/client-chime-sdk-media-pipelines");
var import_client_ssm2 = require("@aws-sdk/client-ssm");
var ssmClient2 = new import_client_ssm2.SSMClient({ region: process.env.AWS_REGION });
var chimeSDKMediaPipelineClient2 = new import_client_chime_sdk_media_pipelines2.ChimeSDKMediaPipelinesClient({
  region: process.env.AWS_REGION
});
function capitalizeKeys2(obj) {
  if (Array.isArray(obj)) {
    return obj.map((item) => capitalizeKeys2(item));
  }
  if (typeof obj === "object") {
    const capitalizedObj = {};
    for (const key in obj) {
      if (obj.hasOwnProperty(key)) {
        const capitalizedKey = key.charAt(0).toUpperCase() + key.slice(1);
        const value = obj[key];
        capitalizedObj[capitalizedKey] = typeof value === "string" && !isNaN(parseFloat(value)) ? parseFloat(value) : capitalizeKeys2(value);
      }
    }
    return capitalizedObj;
  }
  return obj;
}
function capitalizeElementsKeys(elements) {
  return capitalizeKeys2(elements);
}
var createMediaInsightsPipelineConfigurationResponse;
var createMediaInsightsPipelineConfigurationParams;
var formatProps2 = (props) => {
  let formattedElements = [];
  let formattedTags = [];
  let formattedRealTimeAlertConfiguration = {};
  let formattedRealTimeAlertRules = [];
  console.info(`Formatting Props: ${JSON.stringify(props)}`);
  if (props.elements) {
    console.info(`Formatting Elements: ${JSON.stringify(props.elements)}`);
    console.log(`Current formattedElements: ${formattedElements}`);
    props.elements.forEach((element) => {
      formattedElements.push(capitalizeElementsKeys(element));
    });
    console.info(`Formatted Elements: ${JSON.stringify(formattedElements)}`);
  }
  console.log(`New formattedElements: ${formattedElements}`);
  console.log(`Current formattedTags: ${formattedTags}`);
  if (props.tags) {
    console.info(`Formatting Tags: ${JSON.stringify(props.tags)}`);
    props.tags.forEach((tag) => {
      formattedTags.push(capitalizeKeys2(tag));
    });
    console.info(`Formatted Tags: ${JSON.stringify(formattedTags)}`);
  }
  console.log(`New formattedTags: ${formattedTags}`);
  if (props.realTimeAlertConfiguration) {
    console.info(
      `Formatting Real Time Alert Configuration: ${JSON.stringify(
        props.realTimeAlertConfiguration
      )}`
    );
    props.realTimeAlertConfiguration.rules.forEach((rule) => {
      formattedRealTimeAlertRules.push(capitalizeKeys2(rule));
    });
    formattedRealTimeAlertConfiguration = {
      Disabled: props.realTimeAlertConfiguration.disabled,
      Rules: formattedRealTimeAlertRules
    };
    console.info(
      `Formatted Real Time Alert Configuration: ${JSON.stringify(
        formattedRealTimeAlertConfiguration
      )}`
    );
  }
  const mediaInsightsPipelineConfigurationParams = {
    ResourceAccessRoleArn: props.resourceAccessRoleArn,
    MediaInsightsPipelineConfigurationName: props.mediaInsightsPipelineConfigurationName,
    ...props.tags && { Tags: formattedTags },
    ...props.clientRequestToken && {
      ClientRequestToken: props.clientRequestToken
    },
    ...props.elements && {
      Elements: formattedElements
    },
    ...props.realTimeAlertConfiguration && {
      RealTimeAlertConfiguration: formattedRealTimeAlertConfiguration
    }
  };
  console.info(
    `mediaInsightsPipelineConfigurationParams: ${JSON.stringify(
      mediaInsightsPipelineConfigurationParams
    )}`
  );
  return mediaInsightsPipelineConfigurationParams;
};
var CreateMediaInsightsPipelineConfiguration = async (uid, props) => {
  console.log(`Creating Media Insights Pipeline Configuration: ${uid}`);
  console.log(
    `Create Media Insights Pipeline Configuration props: ${JSON.stringify(
      props
    )}`
  );
  createMediaInsightsPipelineConfigurationParams = formatProps2(props);
  console.log(
    `Create Media Insights Pipeline Configuration params: ${JSON.stringify(
      createMediaInsightsPipelineConfigurationParams
    )}`
  );
  try {
    createMediaInsightsPipelineConfigurationResponse = await chimeSDKMediaPipelineClient2.send(
      new import_client_chime_sdk_media_pipelines2.CreateMediaInsightsPipelineConfigurationCommand(
        createMediaInsightsPipelineConfigurationParams
      )
    );
    console.log(
      `createMediaInsightsPipelineConfigurationResponse: ${JSON.stringify(
        createMediaInsightsPipelineConfigurationResponse
      )}`
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  try {
    await ssmClient2.send(
      new import_client_ssm2.PutParameterCommand({
        Name: "/chime/MediaInsightsPipelineConfigurationArn" + uid,
        Value: createMediaInsightsPipelineConfigurationResponse.MediaInsightsPipelineConfiguration.MediaInsightsPipelineConfigurationArn,
        Description: "Media Insight Pipeline Configuration ARN" + uid,
        Overwrite: true,
        Type: "String"
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  return createMediaInsightsPipelineConfigurationResponse.MediaInsightsPipelineConfiguration;
};
var updateMediaInsightsPipelineConfigurationParams;
var updateMediaInsightsPipelineConfigurationResponse;
var updateMediaInsightsPipelineIdentifier;
var getParameterCommandOutput2;
var UpdateMediaInsightsPipelineConfiguration = async (uid, props) => {
  console.log(`Updating Media Insights Pipeline Configuration: ${uid}`);
  console.log(
    `Updating Media Insights Pipeline Configuration props: ${JSON.stringify(
      props
    )}`
  );
  try {
    getParameterCommandOutput2 = await ssmClient2.send(
      new import_client_ssm2.GetParameterCommand({
        Name: "/chime/MediaInsightsPipelineConfigurationArn" + uid
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  updateMediaInsightsPipelineIdentifier = getParameterCommandOutput2.Parameter.Value;
  updateMediaInsightsPipelineConfigurationParams = {
    ...formatProps2(props),
    Identifier: updateMediaInsightsPipelineIdentifier
  };
  console.log(
    `Update Media Insights Pipeline Configuration params: ${JSON.stringify(
      updateMediaInsightsPipelineConfigurationParams
    )}`
  );
  try {
    updateMediaInsightsPipelineConfigurationResponse = await chimeSDKMediaPipelineClient2.send(
      new import_client_chime_sdk_media_pipelines2.UpdateMediaInsightsPipelineConfigurationCommand(
        updateMediaInsightsPipelineConfigurationParams
      )
    );
    console.log(
      `createMediaInsightsPipelineConfigurationResponse: ${JSON.stringify(
        createMediaInsightsPipelineConfigurationResponse
      )}`
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  return updateMediaInsightsPipelineConfigurationResponse.MediaInsightsPipelineConfiguration;
};
var deleteMediaInsightsPipelineIdentifier;
var DeleteMediaInsightsPipelineConfiguration = async (uid) => {
  console.log(`Deleting Media Insights Pipeline Configuration: ${uid}`);
  try {
    getParameterCommandOutput2 = await ssmClient2.send(
      new import_client_ssm2.GetParameterCommand({
        Name: "/chime/MediaInsightsPipelineConfigurationArn" + uid
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  try {
    await ssmClient2.send(
      new import_client_ssm2.DeleteParameterCommand({
        Name: "/chime/MediaInsightsPipelineConfigurationArn" + uid
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  deleteMediaInsightsPipelineIdentifier = getParameterCommandOutput2.Parameter.Value;
  console.info(
    `deleteMediaInsightsPipelineIdentifier: ${deleteMediaInsightsPipelineIdentifier}`
  );
  try {
    await chimeSDKMediaPipelineClient2.send(
      new import_client_chime_sdk_media_pipelines2.DeleteMediaInsightsPipelineConfigurationCommand({
        Identifier: deleteMediaInsightsPipelineIdentifier
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  return;
};

// src/resources/media-pipelines/index.ts
var response = {};
var resourcePropertiesUid;
var requestProperties;
var handler = async (event, context) => {
  console.info("event: ", JSON.stringify(event));
  const resourceType = event.ResourceProperties.resourceType;
  const requestType = event.RequestType;
  resourcePropertiesUid = event.ResourceProperties.uid;
  requestProperties = event.ResourceProperties.properties;
  response.StackId = event.StackId;
  response.RequestId = event.RequestId;
  response.LogicalResourceId = event.LogicalResourceId;
  response.PhysicalResourceId = context.logGroupName;
  switch (resourceType) {
    case "MediaPipelineInsights":
      switch (requestType) {
        case "Create":
          response.Data = await CreateMediaInsightsPipelineConfiguration(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "CreateMediaInsightsPipelineConfiguration successful";
          break;
        case "Update":
          response.Data = await UpdateMediaInsightsPipelineConfiguration(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "UpdateMediaInsightsPipelineConfiguration successful";
          break;
        case "Delete":
          await DeleteMediaInsightsPipelineConfiguration(resourcePropertiesUid);
          response.Status = "SUCCESS";
          response.Reason = "DeleteMediaInsightsPipelineConfiguration successful";
          break;
      }
      break;
    case "KinesisVideoStreamPool":
      switch (requestType) {
        case "Create":
          response.Data = await CreateKinesisVideoStreamPool(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "CreateKinesisVideoStreamPool successful";
          break;
        case "Update":
          response.Data = await UpdateKinesisVideoStreamPool(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "UpdateKinesisVideoStreamPool successful";
          break;
        case "Delete":
          await DeleteKinesisVideoStreamPool(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "DeleteKinesisVideoStreamPool successful";
          break;
      }
      break;
  }
  console.log(`Response: ${JSON.stringify(response)}`);
  return response;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handler
});
