var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/resources/pstn/index.ts
var pstn_exports = {};
__export(pstn_exports, {
  handler: () => handler
});
module.exports = __toCommonJS(pstn_exports);

// src/resources/pstn/phoneAssociation.ts
var import_client_chime_sdk_voice = require("@aws-sdk/client-chime-sdk-voice");
var chimeSDKVoiceClient = new import_client_chime_sdk_voice.ChimeSDKVoiceClient({
  region: "us-east-1"
});
var CreatePhoneAssociation = async (_uid, props) => {
  console.log(
    `Associating Phone Number ${props.e164PhoneNumber} with Voice Connector ${props.voiceConnectorId}`
  );
  if (props.e164PhoneNumber && props.voiceConnectorId) {
    console.log("Associating Phone Number with Voice Connector");
    const associateWithVoiceConnectorParams = {
      VoiceConnectorId: props.voiceConnectorId,
      E164PhoneNumbers: [props.e164PhoneNumber],
      ForceAssociate: true
    };
    await chimeSDKVoiceClient.send(
      new import_client_chime_sdk_voice.AssociatePhoneNumbersWithVoiceConnectorCommand(
        associateWithVoiceConnectorParams
      )
    );
  }
};
var UpdatePhoneAssociation = async (_uid, props) => {
  console.log(
    `Updating Phone Number association ${props.e164PhoneNumber} with Voice Connector ${props.voiceConnectorId}`
  );
  if (props.e164PhoneNumber && props.voiceConnectorId) {
    console.log("Associating Phone Number with Voice Connector");
    const associateWithVoiceConnectorParams = {
      VoiceConnectorId: props.voiceConnectorId,
      E164PhoneNumbers: [props.e164PhoneNumber],
      ForceAssociate: true
    };
    await chimeSDKVoiceClient.send(
      new import_client_chime_sdk_voice.AssociatePhoneNumbersWithVoiceConnectorCommand(
        associateWithVoiceConnectorParams
      )
    );
  }
};
var DeletePhoneAssociation = async (_uid, props) => {
  console.log(
    `Deleting Phone Number association ${props.e164PhoneNumber} with Voice Connector ${props.voiceConnectorId}`
  );
  if (props.e164PhoneNumber && props.voiceConnectorId) {
    console.log("Dissociating Phone Number with Voice Connector");
    const disAssociateWithVoiceConnectorParams = {
      VoiceConnectorId: props.voiceConnectorId,
      E164PhoneNumbers: [props.e164PhoneNumber]
    };
    await chimeSDKVoiceClient.send(
      new import_client_chime_sdk_voice.DisassociatePhoneNumbersFromVoiceConnectorCommand(
        disAssociateWithVoiceConnectorParams
      )
    );
  }
};

// src/resources/pstn/phoneNumber.ts
var import_client_chime_sdk_voice2 = require("@aws-sdk/client-chime-sdk-voice");
var import_client_ssm = require("@aws-sdk/client-ssm");
var chimeSDKVoiceClient2 = new import_client_chime_sdk_voice2.ChimeSDKVoiceClient({
  region: "us-east-1"
});
var ssmClient = new import_client_ssm.SSMClient({ region: process.env.AWS_REGION });
var searchAvailableNumbersParam;
var searchAvailablePhoneNumberResponse;
var createPhoneNumberOrderResponse;
var getParameterCommandOutput;
var getPhoneNumberResponse;
var sleep = (ms) => new Promise((r) => setTimeout(r, ms));
var CreatePhoneNumber = async (uid, props) => {
  searchAvailableNumbersParam = {
    ...props.phoneAreaCode && { AreaCode: props.phoneAreaCode },
    ...props.phoneNumberType && { PhoneNumberType: props.phoneNumberType },
    ...props.phoneState && { State: props.phoneState },
    ...props.phoneCity && { City: props.phoneCity },
    ...props.phoneCountry && { Country: props.phoneCountry },
    ...props.phoneNumberTollFreePrefix && {
      TollFreePrefix: props.phoneNumberTollFreePrefix
    }
  };
  console.info(
    `Search Available Numbers: ${JSON.stringify(searchAvailableNumbersParam)}`
  );
  let orderSuccessful = false;
  let searchAttempts = 1;
  while (searchAttempts < 16) {
    try {
      console.log(
        `Searching for available numbers.  Search # ${searchAttempts}`
      );
      searchAvailablePhoneNumberResponse = await chimeSDKVoiceClient2.send(
        new import_client_chime_sdk_voice2.SearchAvailablePhoneNumbersCommand(searchAvailableNumbersParam)
      );
      console.log(
        `Search Available Numbers Response: ${JSON.stringify(
          searchAvailablePhoneNumberResponse
        )}`
      );
    } catch (error) {
      if (error instanceof Error) {
        console.error(error);
        throw error;
      }
    }
    if (searchAvailablePhoneNumberResponse && searchAvailablePhoneNumberResponse.E164PhoneNumbers && searchAvailablePhoneNumberResponse.E164PhoneNumbers.length === 0) {
      throw new Error(
        "No numbers were found with this search parameters.  Please try a different search."
      );
    }
    try {
      console.log("Creating New Phone Number Order");
      createPhoneNumberOrderResponse = await chimeSDKVoiceClient2.send(
        new import_client_chime_sdk_voice2.CreatePhoneNumberOrderCommand({
          ProductType: props.phoneProductType,
          E164PhoneNumbers: [
            searchAvailablePhoneNumberResponse.E164PhoneNumbers[0]
          ]
        })
      );
      console.log(
        `CreatePhoneNumberOrder Response: ${JSON.stringify(
          createPhoneNumberOrderResponse
        )}`
      );
    } catch (error) {
      if (error instanceof import_client_chime_sdk_voice2.ChimeSDKVoiceServiceException) {
        if (error.name === "BadRequestException") {
          console.log("Bad Request Exception.  Retrying");
          console.error(error);
          searchAttempts++;
          await sleep(1e4);
          continue;
        } else {
          console.error(error);
          throw error;
        }
      }
    }
    let orderAttempts = 0;
    let orderResults = "";
    while (orderAttempts < 20) {
      orderResults = await checkPhoneNumber(
        createPhoneNumberOrderResponse.PhoneNumberOrder.PhoneNumberOrderId
      );
      if (orderResults === "Processing") {
        orderAttempts++;
        await sleep(1e4);
        console.log("Still processing phone number order.  Looping");
        continue;
      } else if (orderResults === "Failed") {
        console.log("Phone number order failed");
        break;
      } else if (orderResults === "Successful") {
        orderSuccessful = true;
        console.log("Phone number order successful");
        break;
      } else {
        console.log("Unknown phone number order status");
        break;
      }
    }
    if (orderSuccessful) {
      break;
    }
  }
  if (!orderSuccessful) {
    throw new Error(
      "The phone number order failed to process.  Please try again."
    );
  }
  try {
    await ssmClient.send(
      new import_client_ssm.PutParameterCommand({
        Name: "/chime/phoneNumber" + uid,
        Value: searchAvailablePhoneNumberResponse.E164PhoneNumbers[0],
        Description: "Phone Number",
        Overwrite: true,
        Type: "String"
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  return {
    phoneNumber: searchAvailablePhoneNumberResponse.E164PhoneNumbers[0]
  };
};
var DeletePhoneNumber = async (uid) => {
  try {
    getParameterCommandOutput = await ssmClient.send(
      new import_client_ssm.GetParameterCommand({ Name: "/chime/phoneNumber" + uid })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  try {
    getPhoneNumberResponse = await chimeSDKVoiceClient2.send(
      new import_client_chime_sdk_voice2.GetPhoneNumberCommand({
        PhoneNumberId: getParameterCommandOutput.Parameter.Value
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  try {
    if (getPhoneNumberResponse.PhoneNumber.Status === "Assigned") {
      if (getPhoneNumberResponse.PhoneNumber.ProductType === "VoiceConnector") {
        await chimeSDKVoiceClient2.send(
          new import_client_chime_sdk_voice2.DisassociatePhoneNumbersFromVoiceConnectorCommand({
            E164PhoneNumbers: [
              getPhoneNumberResponse.PhoneNumber.E164PhoneNumber
            ],
            VoiceConnectorId: getPhoneNumberResponse.PhoneNumber.Associations[0].Value
          })
        );
      } else if (getPhoneNumberResponse.PhoneNumber.ProductType === "SipMediaApplicationDialIn") {
        await chimeSDKVoiceClient2.send(
          new import_client_chime_sdk_voice2.UpdateSipRuleCommand({
            Name: getPhoneNumberResponse.PhoneNumber.E164PhoneNumber,
            SipRuleId: getPhoneNumberResponse.PhoneNumber.Associations[0].Value,
            Disabled: true
          })
        );
      } else {
        throw new Error("Could not disassociate number");
      }
    }
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  await sleep(1e4);
  try {
    await chimeSDKVoiceClient2.send(
      new import_client_chime_sdk_voice2.DeletePhoneNumberCommand({
        PhoneNumberId: getParameterCommandOutput.Parameter.Value
      })
    );
    await ssmClient.send(
      new import_client_ssm.DeleteParameterCommand({ Name: "/chime/phoneNumber" + uid })
    );
  } catch (error) {
  }
};
async function checkPhoneNumber(phoneOrderId) {
  try {
    const getPhoneNumberOrderResponse = await chimeSDKVoiceClient2.send(
      new import_client_chime_sdk_voice2.GetPhoneNumberOrderCommand({ PhoneNumberOrderId: phoneOrderId })
    );
    console.info(
      `Get Phone Number Order: ${JSON.stringify(getPhoneNumberOrderResponse)}`
    );
    return getPhoneNumberOrderResponse.PhoneNumberOrder?.Status;
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
    return;
  }
}

// src/resources/pstn/sipMediaApp.ts
var import_client_chime_sdk_voice3 = require("@aws-sdk/client-chime-sdk-voice");
var import_client_ssm2 = require("@aws-sdk/client-ssm");
var chimeSDKVoiceClient3 = new import_client_chime_sdk_voice3.ChimeSDKVoiceClient({
  region: process.env.AWS_REGION
});
var ssmClient2 = new import_client_ssm2.SSMClient({ region: process.env.AWS_REGION });
var createSipMediaApplicationResponse;
var createSipMediaApplicationParams;
var getParameterCommandOutput2;
var putSipMediaApplicationAlexaSkillInput;
var putSipMediaApplicationLoggingInput;
var putSipMediaApplicationAlexaSkillOutput;
var putSipMediaApplicationLoggingOutput;
var CreateSipMediaApplication = async (uid, props) => {
  console.log(`Creating SIP media application rule: ${uid}`);
  console.log(`Create SIP media application props: ${JSON.stringify(props)}`);
  createSipMediaApplicationParams = {
    Name: props.name,
    AwsRegion: props.region,
    Endpoints: [{ LambdaArn: props.endpoint }]
  };
  console.log(
    `Create SIP media application params: ${JSON.stringify(
      createSipMediaApplicationParams
    )}`
  );
  try {
    createSipMediaApplicationResponse = await chimeSDKVoiceClient3.send(
      new import_client_chime_sdk_voice3.CreateSipMediaApplicationCommand(createSipMediaApplicationParams)
    );
    console.log(
      `createSipMediaApplicationResponse: ${JSON.stringify(
        createSipMediaApplicationResponse
      )}`
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  try {
    await ssmClient2.send(
      new import_client_ssm2.PutParameterCommand({
        Name: "/chime/sipMediaApp" + uid,
        Value: createSipMediaApplicationResponse.SipMediaApplication?.SipMediaApplicationId,
        Description: "SIP Media Application ID",
        Overwrite: true,
        Type: "String"
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  return {
    sipMediaAppId: createSipMediaApplicationResponse.SipMediaApplication?.SipMediaApplicationId
  };
};
var DeleteSipMediaApplication = async (uid) => {
  try {
    getParameterCommandOutput2 = await ssmClient2.send(
      new import_client_ssm2.GetParameterCommand({ Name: "/chime/sipMediaApp" + uid })
    );
    if (getParameterCommandOutput2.Parameter && getParameterCommandOutput2.Parameter.Value) {
    }
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  try {
    await chimeSDKVoiceClient3.send(
      new import_client_chime_sdk_voice3.DeleteSipMediaApplicationCommand({
        SipMediaApplicationId: getParameterCommandOutput2.Parameter?.Value
      })
    );
    await ssmClient2.send(
      new import_client_ssm2.DeleteParameterCommand({ Name: "/chime/sipMediaApp" + uid })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
};
var PutSipMediaApplicationLogging = async (props) => {
  console.log(
    `Put SIP media application logging configuration: ${JSON.stringify(props)}`
  );
  putSipMediaApplicationLoggingInput = {
    SipMediaApplicationId: props.sipMediaAppId,
    SipMediaApplicationLoggingConfiguration: {
      EnableSipMediaApplicationMessageLogs: props.sipMediaApplicationLoggingConfiguration?.sipMediaApplicationLoggingConfiguration?.enableSipMediaApplicationMessageLogs
    }
  };
  try {
    putSipMediaApplicationLoggingOutput = await chimeSDKVoiceClient3.send(
      new import_client_chime_sdk_voice3.PutSipMediaApplicationLoggingConfigurationCommand(
        putSipMediaApplicationLoggingInput
      )
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  return {
    putSipMediaApplicationLoggingConfiguration: putSipMediaApplicationLoggingOutput.SipMediaApplicationLoggingConfiguration
  };
};
var PutSipMediaApplicationAlexaSkill = async (props) => {
  console.log(
    `Put SIP media application Alexa skill configuration: ${JSON.stringify(
      props
    )}`
  );
  putSipMediaApplicationAlexaSkillInput = {
    SipMediaApplicationId: props.sipMediaAppId,
    SipMediaApplicationAlexaSkillConfiguration: {
      AlexaSkillIds: props.sipMediaApplicationAlexaSkillConfiguration?.alexaSkillIds,
      AlexaSkillStatus: props.sipMediaApplicationAlexaSkillConfiguration?.alexaSkillStatus
    }
  };
  try {
    putSipMediaApplicationAlexaSkillOutput = await chimeSDKVoiceClient3.send(
      new import_client_chime_sdk_voice3.PutSipMediaApplicationAlexaSkillConfigurationCommand(
        putSipMediaApplicationAlexaSkillInput
      )
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  return {
    putSipMediaApplicationAlexaSkillConfiguration: putSipMediaApplicationAlexaSkillOutput.SipMediaApplicationAlexaSkillConfiguration
  };
};

// src/resources/pstn/sipRule.ts
var import_client_chime_sdk_voice4 = require("@aws-sdk/client-chime-sdk-voice");
var import_client_ssm3 = require("@aws-sdk/client-ssm");
var chimeSDKVoiceClient4 = new import_client_chime_sdk_voice4.ChimeSDKVoiceClient({
  region: process.env.AWS_REGION
});
var ssmClient3 = new import_client_ssm3.SSMClient({ region: process.env.AWS_REGION });
var createSipRuleParams;
var createSipRuleResponse;
var getParameterCommandOutput3;
var sipRuleToDelete;
var sipRuleTargetApplications;
var CreateSIPRule = async (uid, props) => {
  console.log(`Creating SIP media application rule: ${uid}`);
  console.log(
    `Create SIP media application rule props: ${JSON.stringify(props)}`
  );
  sipRuleTargetApplications = [];
  props.targetApplications?.forEach((targetApplication) => {
    sipRuleTargetApplications.push({
      AwsRegion: targetApplication.region,
      SipMediaApplicationId: targetApplication.sipMediaApplicationId,
      Priority: parseInt(targetApplication.priority)
    });
  });
  createSipRuleParams = {
    Name: props.name,
    TriggerType: props.triggerType,
    TriggerValue: props.triggerValue,
    TargetApplications: sipRuleTargetApplications
  };
  console.log(
    `Create SIP media application rule params: ${JSON.stringify(
      createSipRuleParams
    )}`
  );
  let attempt = 0;
  while (attempt < 10) {
    try {
      console.log(`Attempt ${attempt + 1}: Creating SIP rule`);
      createSipRuleResponse = await chimeSDKVoiceClient4.send(
        new import_client_chime_sdk_voice4.CreateSipRuleCommand(createSipRuleParams)
      );
      console.log(`SIP rule created: ${JSON.stringify(createSipRuleResponse)}`);
      break;
    } catch (error) {
      if (error instanceof import_client_chime_sdk_voice4.ChimeSDKVoiceServiceException && error.name === "BadRequestException") {
        console.error("Bad Request Exception, retrying...", error);
        attempt++;
        await sleep2(1e4);
        continue;
      } else {
        console.error("An unexpected error occurred:", error);
        throw error;
      }
    }
  }
  if (!createSipRuleResponse) {
    throw new Error("Failed to create SIP rule after 3 attempts.");
  }
  try {
    await ssmClient3.send(
      new import_client_ssm3.PutParameterCommand({
        Name: "/chime/sipRule" + uid,
        Value: createSipRuleResponse.SipRule?.SipRuleId,
        Description: "SIP Rule ID",
        Overwrite: true,
        Type: "String"
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  return {
    sipRuleId: createSipRuleResponse.SipRule?.SipRuleId
  };
};
var DeleteSIPRule = async (uid) => {
  try {
    getParameterCommandOutput3 = await ssmClient3.send(
      new import_client_ssm3.GetParameterCommand({ Name: "/chime/sipRule" + uid })
    );
    if (getParameterCommandOutput3.Parameter && getParameterCommandOutput3.Parameter.Value) {
      sipRuleToDelete = getParameterCommandOutput3.Parameter.Value;
    }
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  try {
    await chimeSDKVoiceClient4.send(
      new import_client_chime_sdk_voice4.UpdateSipRuleCommand({
        SipRuleId: sipRuleToDelete,
        Name: uid,
        Disabled: true
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  let getSipRuleCommandCount = 0;
  while (!await chimeSDKVoiceClient4.send(
    new import_client_chime_sdk_voice4.GetSipRuleCommand({ SipRuleId: sipRuleToDelete })
  )) {
    getSipRuleCommandCount++;
    if (getSipRuleCommandCount > 15) {
      throw new Error("Could not disable SIP rule");
    }
    await sleep2(5e3);
  }
  try {
    await chimeSDKVoiceClient4.send(
      new import_client_chime_sdk_voice4.DeleteSipRuleCommand({
        SipRuleId: sipRuleToDelete
      })
    );
    await ssmClient3.send(
      new import_client_ssm3.DeleteParameterCommand({ Name: "/chime/sipRule" + uid })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
};
var sleep2 = (ms) => new Promise((r) => setTimeout(r, ms));

// src/resources/pstn/voiceConnector.ts
var import_client_chime_sdk_voice5 = require("@aws-sdk/client-chime-sdk-voice");
var import_client_cloudwatch_logs = require("@aws-sdk/client-cloudwatch-logs");
var import_client_ssm4 = require("@aws-sdk/client-ssm");
var chimeSDKVoiceClient5 = new import_client_chime_sdk_voice5.ChimeSDKVoiceClient({
  region: process.env.AWS_REGION
});
var ssmClient4 = new import_client_ssm4.SSMClient({ region: process.env.AWS_REGION });
var logClient = new import_client_cloudwatch_logs.CloudWatchLogsClient({ region: process.env.AWS_REGION });
var createVoiceConnectorResponse;
var createVoiceConnectorParams;
var updateVoiceConnectorParams;
var getParameterCommandOutput4;
var voiceConnectorId;
var phoneNumbersToDisassociate;
var routes;
var terminationConfiguration;
var streamingConfiguration;
var loggingConfiguration;
var deleteVoiceConnectorResponse;
var CreateVoiceConnector = async (uid, props) => {
  console.log(`Creating Voice Connector: ${uid}`);
  console.log(`Create Voice Connector Props: ${JSON.stringify(props)}`);
  createVoiceConnectorParams = {
    Name: props.name,
    RequireEncryption: props.encryption,
    AwsRegion: props.region
  };
  console.log(
    `createVoiceConnectorParams: ${JSON.stringify(createVoiceConnectorParams)}`
  );
  try {
    createVoiceConnectorResponse = await chimeSDKVoiceClient5.send(
      new import_client_chime_sdk_voice5.CreateVoiceConnectorCommand(createVoiceConnectorParams)
    );
    console.log(
      `createVoiceConnectorResponse: ${JSON.stringify(
        createVoiceConnectorResponse
      )}`
    );
    if (createVoiceConnectorResponse.VoiceConnector && createVoiceConnectorResponse.VoiceConnector.VoiceConnectorId) {
      voiceConnectorId = createVoiceConnectorResponse.VoiceConnector?.VoiceConnectorId;
    } else {
      throw new Error("Voice Connector failed to create");
    }
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  console.log(`Voice Connector Created: ${voiceConnectorId}`);
  if (props.origination) {
    await putOrigination(voiceConnectorId, props.origination);
  }
  if (props.termination) {
    await putTermination(voiceConnectorId, props.termination);
  }
  if (props.streaming) {
    await putStreaming(voiceConnectorId, props.streaming);
  }
  if (props.logging) {
    await putLogging(voiceConnectorId, props.logging);
  }
  try {
    await ssmClient4.send(
      new import_client_ssm4.PutParameterCommand({
        Name: "/chime/voiceConnector" + uid,
        Value: voiceConnectorId,
        Description: "Voice Connector ID",
        Overwrite: true,
        Type: "String"
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  return {
    voiceConnectorId
  };
};
var UpdateVoiceConnector = async (uid, props) => {
  console.log(`Updating Voice Connector: ${uid}`);
  console.log(`Updating Voice Connector Props: ${JSON.stringify(props)}`);
  updateVoiceConnectorParams = {
    Name: props.name,
    RequireEncryption: props.encryption,
    AwsRegion: props.region
  };
  console.log(
    `updateVoiceConnectorParams: ${JSON.stringify(updateVoiceConnectorParams)}`
  );
  try {
    getParameterCommandOutput4 = await ssmClient4.send(
      new import_client_ssm4.GetParameterCommand({ Name: "/chime/voiceConnector" + uid })
    );
    if (getParameterCommandOutput4.Parameter && getParameterCommandOutput4.Parameter.Value) {
      voiceConnectorId = getParameterCommandOutput4.Parameter.Value;
    }
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  if (props.origination) {
    await putOrigination(voiceConnectorId, props.origination);
  }
  if (props.termination) {
    await putTermination(voiceConnectorId, props.termination);
  }
  if (props.streaming) {
    await putStreaming(voiceConnectorId, props.streaming);
  }
  if (props.logging) {
    await putLogging(voiceConnectorId, props.logging);
  }
  return {
    voiceConnectorId
  };
};
var DeleteVoiceConnector = async (uid) => {
  try {
    getParameterCommandOutput4 = await ssmClient4.send(
      new import_client_ssm4.GetParameterCommand({ Name: "/chime/voiceConnector" + uid })
    );
    if (getParameterCommandOutput4.Parameter && getParameterCommandOutput4.Parameter.Value) {
      voiceConnectorId = getParameterCommandOutput4.Parameter.Value;
    }
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  console.log(`voiceConnectorId to delete: ${voiceConnectorId}`);
  try {
    const phoneNumbersAssociated = await chimeSDKVoiceClient5.send(
      new import_client_chime_sdk_voice5.ListPhoneNumbersCommand({
        FilterName: "VoiceConnectorId",
        FilterValue: voiceConnectorId
      })
    );
    console.log(
      `phoneNumbers to disassociate:  ${JSON.stringify(
        phoneNumbersAssociated
      )}`
    );
    if (phoneNumbersAssociated.PhoneNumbers && phoneNumbersAssociated.PhoneNumbers.length > 0) {
      phoneNumbersAssociated.PhoneNumbers.forEach(async (phoneNumber) => {
        phoneNumbersToDisassociate.push(phoneNumber.PhoneNumberId);
      });
      console.log(`Disassociate Phone Numbers: ${phoneNumbersToDisassociate}`);
      await chimeSDKVoiceClient5.send(
        new import_client_chime_sdk_voice5.DisassociatePhoneNumbersFromVoiceConnectorCommand({
          VoiceConnectorId: voiceConnectorId,
          E164PhoneNumbers: phoneNumbersToDisassociate
        })
      );
    }
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  console.log(`Deleting Voice Connector: ${voiceConnectorId}`);
  try {
    deleteVoiceConnectorResponse = await chimeSDKVoiceClient5.send(
      new import_client_chime_sdk_voice5.DeleteVoiceConnectorCommand({
        VoiceConnectorId: voiceConnectorId
      })
    );
    console.log(
      `Delete Voice Connector Response: ${deleteVoiceConnectorResponse}`
    );
    await ssmClient4.send(
      new import_client_ssm4.DeleteParameterCommand({ Name: "/chime/voiceConnector" + uid })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
};
var putOrigination = async (originationVoiceConnectorId, originations) => {
  console.log(`originations:  ${JSON.stringify(originations)}`);
  console.info(`voiceConnectorId: ${originationVoiceConnectorId}`);
  routes = [];
  originations.forEach(async (origination) => {
    routes.push({
      Protocol: origination.protocol,
      Host: origination.host,
      Port: parseInt(origination.port),
      Priority: parseInt(origination.priority),
      Weight: parseInt(origination.weight)
    });
  });
  console.log(`routes:  ${JSON.stringify(routes)}`);
  try {
    await chimeSDKVoiceClient5.send(
      new import_client_chime_sdk_voice5.PutVoiceConnectorOriginationCommand({
        VoiceConnectorId: originationVoiceConnectorId,
        Origination: {
          Routes: routes,
          Disabled: false
        }
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
};
var putTermination = async (terminationVoiceConnectorId, termination) => {
  console.log(`termination:  ${JSON.stringify(termination)}`);
  console.info(`voiceConnectorId: ${terminationVoiceConnectorId}`);
  terminationConfiguration = {
    CallingRegions: termination.callingRegions,
    CidrAllowedList: termination.terminationCidrs,
    CpsLimit: parseInt(termination.cpsLimit)
  };
  console.log(
    `terminationConfiguration:  ${JSON.stringify(terminationConfiguration)}`
  );
  try {
    await chimeSDKVoiceClient5.send(
      new import_client_chime_sdk_voice5.PutVoiceConnectorTerminationCommand({
        VoiceConnectorId: terminationVoiceConnectorId,
        Termination: terminationConfiguration
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
};
var putStreaming = async (streamingVoiceConnectorId, streaming) => {
  console.log(`streaming:  ${JSON.stringify(streaming)}`);
  console.info(`voiceConnectorId: ${streamingVoiceConnectorId}`);
  streamingConfiguration = {
    StreamingNotificationTargets: streaming.notificationTarget,
    Disabled: false,
    DataRetentionInHours: parseInt(streaming.dataRetention),
    ...streaming.mediaInsightsConfiguration && {
      MediaInsightsConfiguration: {
        Disabled: streaming.mediaInsightsConfiguration.disabled,
        ConfigurationArn: streaming.mediaInsightsConfiguration.configurationArn
      }
    }
  };
  console.log(
    `streamingConfiguration:  ${JSON.stringify(streamingConfiguration)}`
  );
  try {
    await chimeSDKVoiceClient5.send(
      new import_client_chime_sdk_voice5.PutVoiceConnectorStreamingConfigurationCommand({
        VoiceConnectorId: streamingVoiceConnectorId,
        StreamingConfiguration: streamingConfiguration
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
};
var putLogging = async (loggingVoiceConnectorId, logging) => {
  console.log(`logging:  ${JSON.stringify(logging)}`);
  console.info(`voiceConnectorId: ${loggingVoiceConnectorId}`);
  try {
    console.log("Updating Resource Policy");
    const policyDocument = JSON.stringify({
      Version: "2012-10-17",
      Statement: [
        {
          Sid: "AWSLogDeliveryWrite",
          Effect: "Allow",
          Principal: { Service: "delivery.logs.amazonaws.com" },
          Action: ["logs:CreateLogStream", "logs:PutLogEvents"],
          Resource: ["*"]
        }
      ]
    });
    await logClient.send(
      new import_client_cloudwatch_logs.PutResourcePolicyCommand({
        policyName: "msk",
        policyDocument
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  loggingConfiguration = {
    ...logging.enableSIPLogs && { EnableSIPLogs: logging.enableSIPLogs },
    ...logging.enableMediaMetricLogs && {
      EnableMediaMetricLogs: logging.enableMediaMetricLogs
    }
  };
  console.log(`loggingConfiguration:  ${JSON.stringify(loggingConfiguration)}`);
  try {
    await chimeSDKVoiceClient5.send(
      new import_client_chime_sdk_voice5.PutVoiceConnectorLoggingConfigurationCommand({
        VoiceConnectorId: loggingVoiceConnectorId,
        LoggingConfiguration: loggingConfiguration
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
};

// src/resources/pstn/voiceProfileDomain.ts
var import_client_chime_sdk_voice6 = require("@aws-sdk/client-chime-sdk-voice");
var import_client_ssm5 = require("@aws-sdk/client-ssm");
var chimeSDKVoiceClient6 = new import_client_chime_sdk_voice6.ChimeSDKVoiceClient({
  region: process.env.AWS_REGION
});
var ssmClient5 = new import_client_ssm5.SSMClient({ region: process.env.AWS_REGION });
var formattedCreateVoiceProfileDomainParams;
var createVoiceProfileDomainResponse;
var getParameterCommandOutput5;
var voiceProfileDomainId;
var updateVoiceProfileDomainParams;
var updateVoiceProfileDomainResponse;
var deleteVoiceProfileDomainResponse;
var formattedTags = [];
function capitalizeKeys(obj) {
  if (Array.isArray(obj)) {
    return obj.map((item) => capitalizeKeys(item));
  }
  if (typeof obj === "object") {
    const capitalizedObj = {};
    for (const key in obj) {
      if (obj.hasOwnProperty(key)) {
        const capitalizedKey = key.charAt(0).toUpperCase() + key.slice(1);
        const value = obj[key];
        capitalizedObj[capitalizedKey] = typeof value === "string" && !isNaN(parseFloat(value)) ? parseFloat(value) : capitalizeKeys(value);
      }
    }
    return capitalizedObj;
  }
  return obj;
}
var formatProps = (props) => {
  console.info(`Formatting Props: ${JSON.stringify(props)}`);
  if (props.tags) {
    console.info(`Formatting Tags: ${JSON.stringify(props.tags)}`);
    props.tags.forEach((tag) => {
      formattedTags.push(capitalizeKeys(tag));
    });
    console.info(`Formatted Tags: ${JSON.stringify(formattedTags)}`);
  }
  formattedCreateVoiceProfileDomainParams = {
    Name: props.name,
    ...props.tags && { Tags: formattedTags },
    ...props.clientRequestToken && {
      ClientRequestToken: props.clientRequestToken
    },
    ...props.description && { Description: props.description },
    ...props.serverSideEncryptionConfiguration && {
      ServerSideEncryptionConfiguration: {
        KmsKeyArn: props.serverSideEncryptionConfiguration.kmsKeyArn
      }
    }
  };
  return formattedCreateVoiceProfileDomainParams;
};
var CreateVoiceProfileDomain = async (uid, props) => {
  console.log(`Creating Voice Profile Domain: ${uid}`);
  console.log(`Create Voice Profile DomainProps: ${JSON.stringify(props)}`);
  formattedCreateVoiceProfileDomainParams = formatProps(props);
  console.log(
    `Create Voice Profile Domain params: ${JSON.stringify(
      formattedCreateVoiceProfileDomainParams
    )}`
  );
  console.log(
    `createVoiceProfileDomainParams: ${JSON.stringify(
      formattedCreateVoiceProfileDomainParams
    )}`
  );
  try {
    createVoiceProfileDomainResponse = await chimeSDKVoiceClient6.send(
      new import_client_chime_sdk_voice6.CreateVoiceProfileDomainCommand(
        formattedCreateVoiceProfileDomainParams
      )
    );
    console.log(
      `createVoiceConnectorResponse: ${JSON.stringify(
        createVoiceProfileDomainResponse
      )}`
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  try {
    await ssmClient5.send(
      new import_client_ssm5.PutParameterCommand({
        Name: "/chime/voiceProfileDomain" + uid,
        Value: createVoiceProfileDomainResponse.VoiceProfileDomain.VoiceProfileDomainId,
        Description: "Voice Profile Domain ID",
        Overwrite: true,
        Type: "String"
      })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  return createVoiceProfileDomainResponse.VoiceProfileDomain;
};
var UpdateVoiceProfileDomain = async (uid, props) => {
  console.log(`Updating Voice Profile Domain: ${uid}`);
  console.log(`Update Voice Profile DomainProps: ${JSON.stringify(props)}`);
  try {
    getParameterCommandOutput5 = await ssmClient5.send(
      new import_client_ssm5.GetParameterCommand({ Name: "/chime/voiceProfileDomain" + uid })
    );
    if (getParameterCommandOutput5.Parameter && getParameterCommandOutput5.Parameter.Value) {
      voiceProfileDomainId = getParameterCommandOutput5.Parameter.Value;
    }
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  updateVoiceProfileDomainParams = {
    Name: props.name,
    Description: props.description,
    VoiceProfileDomainId: voiceProfileDomainId
  };
  console.log(
    `updateVoiceConnectorParams: ${JSON.stringify(
      updateVoiceProfileDomainParams
    )}`
  );
  try {
    updateVoiceProfileDomainResponse = await chimeSDKVoiceClient6.send(
      new import_client_chime_sdk_voice6.UpdateVoiceProfileDomainCommand(updateVoiceProfileDomainParams)
    );
    console.log(
      `updateVoiceProfileDomainResponse: ${JSON.stringify(
        updateVoiceProfileDomainResponse
      )}`
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  return {
    voiceProfileDomain: updateVoiceProfileDomainResponse.VoiceProfileDomain
  };
};
var DeleteVoiceProfileDomain = async (uid) => {
  try {
    getParameterCommandOutput5 = await ssmClient5.send(
      new import_client_ssm5.GetParameterCommand({ Name: "/chime/voiceProfileDomain" + uid })
    );
    if (getParameterCommandOutput5.Parameter && getParameterCommandOutput5.Parameter.Value) {
      voiceProfileDomainId = getParameterCommandOutput5.Parameter.Value;
    }
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
  console.log(`Deleting voiceProfileDomainId: ${voiceProfileDomainId}`);
  try {
    deleteVoiceProfileDomainResponse = await chimeSDKVoiceClient6.send(
      new import_client_chime_sdk_voice6.DeleteVoiceProfileDomainCommand({
        VoiceProfileDomainId: voiceProfileDomainId
      })
    );
    console.log(
      `Delete Voice Profile Domain Response: ${deleteVoiceProfileDomainResponse}`
    );
    await ssmClient5.send(
      new import_client_ssm5.DeleteParameterCommand({ Name: "/chime/voiceProfileDomain" + uid })
    );
  } catch (error) {
    if (error instanceof Error) {
      console.error(error);
      throw error;
    }
  }
};

// src/resources/pstn/index.ts
var response = {};
var resourcePropertiesUid;
var requestProperties;
var handler = async (event, context) => {
  console.info("event: ", event);
  const resourceType = event.ResourceProperties.resourceType;
  const requestType = event.RequestType;
  resourcePropertiesUid = event.ResourceProperties.uid;
  requestProperties = event.ResourceProperties.properties;
  response.StackId = event.StackId;
  response.RequestId = event.RequestId;
  response.LogicalResourceId = event.LogicalResourceId;
  response.PhysicalResourceId = context.logGroupName;
  switch (resourceType) {
    case "PhoneNumber":
      switch (requestType) {
        case "Create":
          console.log("Create Phone Number");
          response.Data = await CreatePhoneNumber(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "CreatePhoneNumber successful";
          break;
        case "Update":
          console.log("Update Phone Number");
          response.Status = "SUCCESS";
          break;
        case "Delete":
          console.log("Delete Phone Number");
          await DeletePhoneNumber(resourcePropertiesUid);
          response.Status = "SUCCESS";
          response.Reason = "DeletePhoneNumber successful";
          break;
      }
      break;
    case "SMARule":
      switch (requestType) {
        case "Create":
          console.log("Create SIP Rule");
          response.Data = await CreateSIPRule(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "CreateSMARule successful";
          break;
        case "Update":
          console.log("Update SIP Rule");
          response.Status = "SUCCESS";
          break;
        case "Delete":
          console.log("Delete SIP Rule");
          await DeleteSIPRule(resourcePropertiesUid);
          response.Status = "SUCCESS";
          response.Reason = "DeleteSMARule successful";
          break;
      }
      break;
    case "SMA":
      switch (requestType) {
        case "Create":
          console.log("Create SIP Media Application");
          response.Data = await CreateSipMediaApplication(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "Create SMA successful";
          break;
        case "Update":
          console.log("Update SIP Media Application");
          response.Status = "SUCCESS";
          break;
        case "Delete":
          console.log("Delete SIP Media Application");
          await DeleteSipMediaApplication(resourcePropertiesUid);
          response.Status = "SUCCESS";
          response.Reason = "Delete SMA successful";
          break;
      }
      break;
    case "SMALogging":
      switch (requestType) {
        case "Create":
          console.log("Create SIP Media Application Logging");
          response.Data = await PutSipMediaApplicationLogging(
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "PutSipMediaApplicationLogging successful";
          break;
        case "Update":
          console.log("Update SIP Media Application Logging");
          response.Data = await PutSipMediaApplicationLogging(
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "PutSipMediaApplicationLogging successful";
          break;
        case "Delete":
          console.log("Delete SIP Media Application Logging");
          response.Status = "SUCCESS";
          response.Reason = "PutSipMediaApplicationLogging Delete NoOP";
          break;
      }
      break;
    case "SMAAlexaSkill":
      switch (requestType) {
        case "Create":
          console.log("Create SIP Media Application Alexa Skill");
          response.Data = await PutSipMediaApplicationAlexaSkill(
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "PutSipMediaApplicationAlexaSkill successful";
          break;
        case "Update":
          console.log("Update SIP Media Application Alexa Skill");
          response.Data = await PutSipMediaApplicationAlexaSkill(
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "PutSipMediaApplicationAlexaSkill successful";
          break;
        case "Delete":
          console.log("DSIP Media Application Alexa Skill");
          response.Status = "SUCCESS";
          response.Reason = "PutSipMediaApplicationAlexaSkill Delete NoOP";
          break;
      }
      break;
    case "VoiceConnector":
      switch (requestType) {
        case "Create":
          console.log("Voice Connector Create");
          response.Data = await CreateVoiceConnector(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "Create VC successful";
          break;
        case "Update":
          console.log("Voice Connector Update");
          response.Data = await UpdateVoiceConnector(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "Update VC successful";
          break;
        case "Delete":
          console.log("Voice Connector Delete");
          await DeleteVoiceConnector(resourcePropertiesUid);
          response.Status = "SUCCESS";
          response.Reason = "Delete VC successful";
          break;
      }
      break;
    case "VoiceProfileDomain":
      switch (requestType) {
        case "Create":
          console.log("Voice Profile Domain Create");
          response.Data = await CreateVoiceProfileDomain(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "Create Voice Profile Domain successful";
          break;
        case "Update":
          console.log("Voice Profile Domain Update");
          await UpdateVoiceProfileDomain(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          break;
        case "Delete":
          console.log("Voice Profile Domain Delete");
          await DeleteVoiceProfileDomain(resourcePropertiesUid);
          response.Status = "SUCCESS";
          response.Reason = "Delete Voice Profile Domain successful";
          break;
      }
      break;
    case "PhoneAssociation":
      console.log("Phone Association");
      switch (requestType) {
        case "Create":
          console.log("Phone Association Create");
          await CreatePhoneAssociation(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "Phone Number Association successful";
          break;
        case "Update":
          console.log("Phone Association Update");
          await UpdatePhoneAssociation(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          break;
        case "Delete":
          console.log("Phone Association Delete");
          await DeletePhoneAssociation(
            resourcePropertiesUid,
            requestProperties
          );
          response.Status = "SUCCESS";
          response.Reason = "Phone Number Dissociation successful";
          break;
      }
      break;
  }
  console.log(`Response: ${JSON.stringify(response)}`);
  return response;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handler
});
