import { StreamingNotificationTarget } from '@aws-sdk/client-chime-sdk-voice';
import { MediaInsightsConfiguration, Protocol } from '../../pstn/voiceConnector';
declare enum VoiceConnectorRegion {
    US_EAST_1 = "us-east-1",
    US_WEST_2 = "us-west-2",
    CA_CENTRAL_1 = "ca-central-1",
    AP_NORTHEAST_1 = "ap-northeast-1",
    AP_NORTHEAST_2 = "ap-northeast-2",
    AP_SOUTHEAST_1 = "ap-southeast-1",
    AP_SOUTHEAST_2 = "ap-southeast-2",
    EU_WEST_1 = "eu-west-1",
    EU_WEST_2 = "eu-west-2",
    EU_CENTRAL_1 = "eu-central-1"
}
interface Routes {
    protocol: Protocol;
    host: string;
    port: string;
    priority: string;
    weight: string;
}
interface TerminationProps {
    callingRegions: string[];
    terminationCidrs: string[];
    cpsLimit: string;
}
interface StreamingProps {
    enabled: boolean;
    dataRetention: string;
    notificationTarget: StreamingNotificationTarget[];
    mediaInsightsConfiguration: MediaInsightsConfiguration;
}
interface LoggingProps {
    enableSIPLogs: boolean;
    enableMediaMetricLogs: boolean;
}
export interface CreateVoiceConnectorProps {
    name?: string;
    region?: VoiceConnectorRegion;
    encryption?: boolean;
    termination?: TerminationProps;
    origination?: Routes[];
    logging?: LoggingProps;
    streaming?: StreamingProps;
}
export declare const CreateVoiceConnector: (uid: string, props: CreateVoiceConnectorProps) => Promise<{
    voiceConnectorId: string;
}>;
export interface UpdateVoiceConnectorProps {
    name?: string;
    region?: VoiceConnectorRegion;
    encryption?: boolean;
    termination?: TerminationProps;
    origination?: Routes[];
    logging?: LoggingProps;
    streaming?: StreamingProps;
}
export declare const UpdateVoiceConnector: (uid: string, props: UpdateVoiceConnectorProps) => Promise<{
    voiceConnectorId: string;
}>;
export declare const DeleteVoiceConnector: (uid: string) => Promise<void>;
export {};
