import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { DescribeAppInstanceAdminResponseFilterSensitiveLog, } from "../models/models_0";
import { de_DescribeAppInstanceAdminCommand, se_DescribeAppInstanceAdminCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class DescribeAppInstanceAdminCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeIdentityService", "DescribeAppInstanceAdmin", {})
    .n("ChimeSDKIdentityClient", "DescribeAppInstanceAdminCommand")
    .f(void 0, DescribeAppInstanceAdminResponseFilterSensitiveLog)
    .ser(se_DescribeAppInstanceAdminCommand)
    .de(de_DescribeAppInstanceAdminCommand)
    .build() {
}
