import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { DescribeAppInstanceUserResponseFilterSensitiveLog, } from "../models/models_0";
import { de_DescribeAppInstanceUserCommand, se_DescribeAppInstanceUserCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class DescribeAppInstanceUserCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeIdentityService", "DescribeAppInstanceUser", {})
    .n("ChimeSDKIdentityClient", "DescribeAppInstanceUserCommand")
    .f(void 0, DescribeAppInstanceUserResponseFilterSensitiveLog)
    .ser(se_DescribeAppInstanceUserCommand)
    .de(de_DescribeAppInstanceUserCommand)
    .build() {
}
