import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { ListAppInstanceBotsRequestFilterSensitiveLog, ListAppInstanceBotsResponseFilterSensitiveLog, } from "../models/models_0";
import { de_ListAppInstanceBotsCommand, se_ListAppInstanceBotsCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class ListAppInstanceBotsCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeIdentityService", "ListAppInstanceBots", {})
    .n("ChimeSDKIdentityClient", "ListAppInstanceBotsCommand")
    .f(ListAppInstanceBotsRequestFilterSensitiveLog, ListAppInstanceBotsResponseFilterSensitiveLog)
    .ser(se_ListAppInstanceBotsCommand)
    .de(de_ListAppInstanceBotsCommand)
    .build() {
}
