import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { ListAppInstancesRequestFilterSensitiveLog, ListAppInstancesResponseFilterSensitiveLog, } from "../models/models_0";
import { de_ListAppInstancesCommand, se_ListAppInstancesCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class ListAppInstancesCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeIdentityService", "ListAppInstances", {})
    .n("ChimeSDKIdentityClient", "ListAppInstancesCommand")
    .f(ListAppInstancesRequestFilterSensitiveLog, ListAppInstancesResponseFilterSensitiveLog)
    .ser(se_ListAppInstancesCommand)
    .de(de_ListAppInstancesCommand)
    .build() {
}
