import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { RegisterAppInstanceUserEndpointRequestFilterSensitiveLog, } from "../models/models_0";
import { de_RegisterAppInstanceUserEndpointCommand, se_RegisterAppInstanceUserEndpointCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class RegisterAppInstanceUserEndpointCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeIdentityService", "RegisterAppInstanceUserEndpoint", {})
    .n("ChimeSDKIdentityClient", "RegisterAppInstanceUserEndpointCommand")
    .f(RegisterAppInstanceUserEndpointRequestFilterSensitiveLog, void 0)
    .ser(se_RegisterAppInstanceUserEndpointCommand)
    .de(de_RegisterAppInstanceUserEndpointCommand)
    .build() {
}
