import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { CreateMediaInsightsPipelineConfigurationRequestFilterSensitiveLog, CreateMediaInsightsPipelineConfigurationResponseFilterSensitiveLog, } from "../models/models_0";
import { de_CreateMediaInsightsPipelineConfigurationCommand, se_CreateMediaInsightsPipelineConfigurationCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class CreateMediaInsightsPipelineConfigurationCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKMediaPipelinesService", "CreateMediaInsightsPipelineConfiguration", {})
    .n("ChimeSDKMediaPipelinesClient", "CreateMediaInsightsPipelineConfigurationCommand")
    .f(CreateMediaInsightsPipelineConfigurationRequestFilterSensitiveLog, CreateMediaInsightsPipelineConfigurationResponseFilterSensitiveLog)
    .ser(se_CreateMediaInsightsPipelineConfigurationCommand)
    .de(de_CreateMediaInsightsPipelineConfigurationCommand)
    .build() {
}
