import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { CreateMediaLiveConnectorPipelineRequestFilterSensitiveLog, CreateMediaLiveConnectorPipelineResponseFilterSensitiveLog, } from "../models/models_0";
import { de_CreateMediaLiveConnectorPipelineCommand, se_CreateMediaLiveConnectorPipelineCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class CreateMediaLiveConnectorPipelineCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKMediaPipelinesService", "CreateMediaLiveConnectorPipeline", {})
    .n("ChimeSDKMediaPipelinesClient", "CreateMediaLiveConnectorPipelineCommand")
    .f(CreateMediaLiveConnectorPipelineRequestFilterSensitiveLog, CreateMediaLiveConnectorPipelineResponseFilterSensitiveLog)
    .ser(se_CreateMediaLiveConnectorPipelineCommand)
    .de(de_CreateMediaLiveConnectorPipelineCommand)
    .build() {
}
