import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { CreateMediaPipelineKinesisVideoStreamPoolRequestFilterSensitiveLog, CreateMediaPipelineKinesisVideoStreamPoolResponseFilterSensitiveLog, } from "../models/models_0";
import { de_CreateMediaPipelineKinesisVideoStreamPoolCommand, se_CreateMediaPipelineKinesisVideoStreamPoolCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class CreateMediaPipelineKinesisVideoStreamPoolCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKMediaPipelinesService", "CreateMediaPipelineKinesisVideoStreamPool", {})
    .n("ChimeSDKMediaPipelinesClient", "CreateMediaPipelineKinesisVideoStreamPoolCommand")
    .f(CreateMediaPipelineKinesisVideoStreamPoolRequestFilterSensitiveLog, CreateMediaPipelineKinesisVideoStreamPoolResponseFilterSensitiveLog)
    .ser(se_CreateMediaPipelineKinesisVideoStreamPoolCommand)
    .de(de_CreateMediaPipelineKinesisVideoStreamPoolCommand)
    .build() {
}
