import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetMediaPipelineResponseFilterSensitiveLog, } from "../models/models_0";
import { de_GetMediaPipelineCommand, se_GetMediaPipelineCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class GetMediaPipelineCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKMediaPipelinesService", "GetMediaPipeline", {})
    .n("ChimeSDKMediaPipelinesClient", "GetMediaPipelineCommand")
    .f(void 0, GetMediaPipelineResponseFilterSensitiveLog)
    .ser(se_GetMediaPipelineCommand)
    .de(de_GetMediaPipelineCommand)
    .build() {
}
