import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetMediaPipelineKinesisVideoStreamPoolResponseFilterSensitiveLog, } from "../models/models_0";
import { de_GetMediaPipelineKinesisVideoStreamPoolCommand, se_GetMediaPipelineKinesisVideoStreamPoolCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class GetMediaPipelineKinesisVideoStreamPoolCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKMediaPipelinesService", "GetMediaPipelineKinesisVideoStreamPool", {})
    .n("ChimeSDKMediaPipelinesClient", "GetMediaPipelineKinesisVideoStreamPoolCommand")
    .f(void 0, GetMediaPipelineKinesisVideoStreamPoolResponseFilterSensitiveLog)
    .ser(se_GetMediaPipelineKinesisVideoStreamPoolCommand)
    .de(de_GetMediaPipelineKinesisVideoStreamPoolCommand)
    .build() {
}
