import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { StartVoiceToneAnalysisTaskRequestFilterSensitiveLog, } from "../models/models_0";
import { de_StartVoiceToneAnalysisTaskCommand, se_StartVoiceToneAnalysisTaskCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class StartVoiceToneAnalysisTaskCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKMediaPipelinesService", "StartVoiceToneAnalysisTask", {})
    .n("ChimeSDKMediaPipelinesClient", "StartVoiceToneAnalysisTaskCommand")
    .f(StartVoiceToneAnalysisTaskRequestFilterSensitiveLog, void 0)
    .ser(se_StartVoiceToneAnalysisTaskCommand)
    .de(de_StartVoiceToneAnalysisTaskCommand)
    .build() {
}
