import { AwsSdkSigV4AuthInputConfig, AwsSdkSigV4AuthResolvedConfig, AwsSdkSigV4PreviouslyResolved } from "@aws-sdk/core";
import { HandlerExecutionContext, HttpAuthScheme, HttpAuthSchemeParameters, HttpAuthSchemeParametersProvider, HttpAuthSchemeProvider } from "@smithy/types";
import { ChimeSDKMediaPipelinesClientResolvedConfig } from "../ChimeSDKMediaPipelinesClient";
/**
 * @internal
 */
export interface ChimeSDKMediaPipelinesHttpAuthSchemeParameters extends HttpAuthSchemeParameters {
    region?: string;
}
/**
 * @internal
 */
export interface ChimeSDKMediaPipelinesHttpAuthSchemeParametersProvider extends HttpAuthSchemeParametersProvider<ChimeSDKMediaPipelinesClientResolvedConfig, HandlerExecutionContext, ChimeSDKMediaPipelinesHttpAuthSchemeParameters, object> {
}
/**
 * @internal
 */
export declare const defaultChimeSDKMediaPipelinesHttpAuthSchemeParametersProvider: (config: ChimeSDKMediaPipelinesClientResolvedConfig, context: HandlerExecutionContext, input: object) => Promise<ChimeSDKMediaPipelinesHttpAuthSchemeParameters>;
/**
 * @internal
 */
export interface ChimeSDKMediaPipelinesHttpAuthSchemeProvider extends HttpAuthSchemeProvider<ChimeSDKMediaPipelinesHttpAuthSchemeParameters> {
}
/**
 * @internal
 */
export declare const defaultChimeSDKMediaPipelinesHttpAuthSchemeProvider: ChimeSDKMediaPipelinesHttpAuthSchemeProvider;
/**
 * @internal
 */
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
    /**
     * experimentalIdentityAndAuth: Configuration of HttpAuthSchemes for a client which provides default identity providers and signers per auth scheme.
     * @internal
     */
    httpAuthSchemes?: HttpAuthScheme[];
    /**
     * experimentalIdentityAndAuth: Configuration of an HttpAuthSchemeProvider for a client which resolves which HttpAuthScheme to use.
     * @internal
     */
    httpAuthSchemeProvider?: ChimeSDKMediaPipelinesHttpAuthSchemeProvider;
}
/**
 * @internal
 */
export interface HttpAuthSchemeResolvedConfig extends AwsSdkSigV4AuthResolvedConfig {
    /**
     * experimentalIdentityAndAuth: Configuration of HttpAuthSchemes for a client which provides default identity providers and signers per auth scheme.
     * @internal
     */
    readonly httpAuthSchemes: HttpAuthScheme[];
    /**
     * experimentalIdentityAndAuth: Configuration of an HttpAuthSchemeProvider for a client which resolves which HttpAuthScheme to use.
     * @internal
     */
    readonly httpAuthSchemeProvider: ChimeSDKMediaPipelinesHttpAuthSchemeProvider;
}
/**
 * @internal
 */
export declare const resolveHttpAuthSchemeConfig: <T>(config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved) => T & HttpAuthSchemeResolvedConfig;
