import { AwsSdkSigV4AuthInputConfig, AwsSdkSigV4AuthResolvedConfig, AwsSdkSigV4PreviouslyResolved } from "@aws-sdk/core";
import { HandlerExecutionContext, HttpAuthScheme, HttpAuthSchemeParameters, HttpAuthSchemeParametersProvider, HttpAuthSchemeProvider } from "@smithy/types";
import { ChimeSDKMessagingClientResolvedConfig } from "../ChimeSDKMessagingClient";
/**
 * @internal
 */
export interface ChimeSDKMessagingHttpAuthSchemeParameters extends HttpAuthSchemeParameters {
    region?: string;
}
/**
 * @internal
 */
export interface ChimeSDKMessagingHttpAuthSchemeParametersProvider extends HttpAuthSchemeParametersProvider<ChimeSDKMessagingClientResolvedConfig, HandlerExecutionContext, ChimeSDKMessagingHttpAuthSchemeParameters, object> {
}
/**
 * @internal
 */
export declare const defaultChimeSDKMessagingHttpAuthSchemeParametersProvider: (config: ChimeSDKMessagingClientResolvedConfig, context: HandlerExecutionContext, input: object) => Promise<ChimeSDKMessagingHttpAuthSchemeParameters>;
/**
 * @internal
 */
export interface ChimeSDKMessagingHttpAuthSchemeProvider extends HttpAuthSchemeProvider<ChimeSDKMessagingHttpAuthSchemeParameters> {
}
/**
 * @internal
 */
export declare const defaultChimeSDKMessagingHttpAuthSchemeProvider: ChimeSDKMessagingHttpAuthSchemeProvider;
/**
 * @internal
 */
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
    /**
     * experimentalIdentityAndAuth: Configuration of HttpAuthSchemes for a client which provides default identity providers and signers per auth scheme.
     * @internal
     */
    httpAuthSchemes?: HttpAuthScheme[];
    /**
     * experimentalIdentityAndAuth: Configuration of an HttpAuthSchemeProvider for a client which resolves which HttpAuthScheme to use.
     * @internal
     */
    httpAuthSchemeProvider?: ChimeSDKMessagingHttpAuthSchemeProvider;
}
/**
 * @internal
 */
export interface HttpAuthSchemeResolvedConfig extends AwsSdkSigV4AuthResolvedConfig {
    /**
     * experimentalIdentityAndAuth: Configuration of HttpAuthSchemes for a client which provides default identity providers and signers per auth scheme.
     * @internal
     */
    readonly httpAuthSchemes: HttpAuthScheme[];
    /**
     * experimentalIdentityAndAuth: Configuration of an HttpAuthSchemeProvider for a client which resolves which HttpAuthScheme to use.
     * @internal
     */
    readonly httpAuthSchemeProvider: ChimeSDKMessagingHttpAuthSchemeProvider;
}
/**
 * @internal
 */
export declare const resolveHttpAuthSchemeConfig: <T>(config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved) => T & HttpAuthSchemeResolvedConfig;
