import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { CreateSipMediaApplicationRequestFilterSensitiveLog, CreateSipMediaApplicationResponseFilterSensitiveLog, } from "../models/models_0";
import { de_CreateSipMediaApplicationCommand, se_CreateSipMediaApplicationCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class CreateSipMediaApplicationCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "CreateSipMediaApplication", {})
    .n("ChimeSDKVoiceClient", "CreateSipMediaApplicationCommand")
    .f(CreateSipMediaApplicationRequestFilterSensitiveLog, CreateSipMediaApplicationResponseFilterSensitiveLog)
    .ser(se_CreateSipMediaApplicationCommand)
    .de(de_CreateSipMediaApplicationCommand)
    .build() {
}
