import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetPhoneNumberSettingsResponseFilterSensitiveLog } from "../models/models_0";
import { de_GetPhoneNumberSettingsCommand, se_GetPhoneNumberSettingsCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class GetPhoneNumberSettingsCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "GetPhoneNumberSettings", {})
    .n("ChimeSDKVoiceClient", "GetPhoneNumberSettingsCommand")
    .f(void 0, GetPhoneNumberSettingsResponseFilterSensitiveLog)
    .ser(se_GetPhoneNumberSettingsCommand)
    .de(de_GetPhoneNumberSettingsCommand)
    .build() {
}
