import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetSipMediaApplicationResponseFilterSensitiveLog, } from "../models/models_0";
import { de_GetSipMediaApplicationCommand, se_GetSipMediaApplicationCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class GetSipMediaApplicationCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "GetSipMediaApplication", {})
    .n("ChimeSDKVoiceClient", "GetSipMediaApplicationCommand")
    .f(void 0, GetSipMediaApplicationResponseFilterSensitiveLog)
    .ser(se_GetSipMediaApplicationCommand)
    .de(de_GetSipMediaApplicationCommand)
    .build() {
}
