import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_ListAvailableVoiceConnectorRegionsCommand, se_ListAvailableVoiceConnectorRegionsCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class ListAvailableVoiceConnectorRegionsCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "ListAvailableVoiceConnectorRegions", {})
    .n("ChimeSDKVoiceClient", "ListAvailableVoiceConnectorRegionsCommand")
    .f(void 0, void 0)
    .ser(se_ListAvailableVoiceConnectorRegionsCommand)
    .de(de_ListAvailableVoiceConnectorRegionsCommand)
    .build() {
}
