import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { ListVoiceProfileDomainsResponseFilterSensitiveLog, } from "../models/models_0";
import { de_ListVoiceProfileDomainsCommand, se_ListVoiceProfileDomainsCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class ListVoiceProfileDomainsCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "ListVoiceProfileDomains", {})
    .n("ChimeSDKVoiceClient", "ListVoiceProfileDomainsCommand")
    .f(void 0, ListVoiceProfileDomainsResponseFilterSensitiveLog)
    .ser(se_ListVoiceProfileDomainsCommand)
    .de(de_ListVoiceProfileDomainsCommand)
    .build() {
}
