import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { PutVoiceConnectorStreamingConfigurationRequestFilterSensitiveLog, PutVoiceConnectorStreamingConfigurationResponseFilterSensitiveLog, } from "../models/models_0";
import { de_PutVoiceConnectorStreamingConfigurationCommand, se_PutVoiceConnectorStreamingConfigurationCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class PutVoiceConnectorStreamingConfigurationCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "PutVoiceConnectorStreamingConfiguration", {})
    .n("ChimeSDKVoiceClient", "PutVoiceConnectorStreamingConfigurationCommand")
    .f(PutVoiceConnectorStreamingConfigurationRequestFilterSensitiveLog, PutVoiceConnectorStreamingConfigurationResponseFilterSensitiveLog)
    .ser(se_PutVoiceConnectorStreamingConfigurationCommand)
    .de(de_PutVoiceConnectorStreamingConfigurationCommand)
    .build() {
}
