import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { PutVoiceConnectorTerminationCredentialsRequestFilterSensitiveLog, } from "../models/models_0";
import { de_PutVoiceConnectorTerminationCredentialsCommand, se_PutVoiceConnectorTerminationCredentialsCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class PutVoiceConnectorTerminationCredentialsCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "PutVoiceConnectorTerminationCredentials", {})
    .n("ChimeSDKVoiceClient", "PutVoiceConnectorTerminationCredentialsCommand")
    .f(PutVoiceConnectorTerminationCredentialsRequestFilterSensitiveLog, void 0)
    .ser(se_PutVoiceConnectorTerminationCredentialsCommand)
    .de(de_PutVoiceConnectorTerminationCredentialsCommand)
    .build() {
}
