import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { UpdatePhoneNumberSettingsRequestFilterSensitiveLog, } from "../models/models_0";
import { de_UpdatePhoneNumberSettingsCommand, se_UpdatePhoneNumberSettingsCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class UpdatePhoneNumberSettingsCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "UpdatePhoneNumberSettings", {})
    .n("ChimeSDKVoiceClient", "UpdatePhoneNumberSettingsCommand")
    .f(UpdatePhoneNumberSettingsRequestFilterSensitiveLog, void 0)
    .ser(se_UpdatePhoneNumberSettingsCommand)
    .de(de_UpdatePhoneNumberSettingsCommand)
    .build() {
}
