import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { UpdateProxySessionResponseFilterSensitiveLog, } from "../models/models_0";
import { de_UpdateProxySessionCommand, se_UpdateProxySessionCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class UpdateProxySessionCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ChimeSDKTelephonyService", "UpdateProxySession", {})
    .n("ChimeSDKVoiceClient", "UpdateProxySessionCommand")
    .f(void 0, UpdateProxySessionResponseFilterSensitiveLog)
    .ser(se_UpdateProxySessionCommand)
    .de(de_UpdateProxySessionCommand)
    .build() {
}
