import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_DescribeDeliverySourcesCommand, se_DescribeDeliverySourcesCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class DescribeDeliverySourcesCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("Logs_20140328", "DescribeDeliverySources", {})
    .n("CloudWatchLogsClient", "DescribeDeliverySourcesCommand")
    .f(void 0, void 0)
    .ser(se_DescribeDeliverySourcesCommand)
    .de(de_DescribeDeliverySourcesCommand)
    .build() {
}
