import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { StartEdgeConfigurationUpdateInputFilterSensitiveLog, StartEdgeConfigurationUpdateOutputFilterSensitiveLog, } from "../models/models_0";
import { de_StartEdgeConfigurationUpdateCommand, se_StartEdgeConfigurationUpdateCommand, } from "../protocols/Aws_restJson1";
export { $Command };
export class StartEdgeConfigurationUpdateCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("KinesisVideo_20170930", "StartEdgeConfigurationUpdate", {})
    .n("KinesisVideoClient", "StartEdgeConfigurationUpdateCommand")
    .f(StartEdgeConfigurationUpdateInputFilterSensitiveLog, StartEdgeConfigurationUpdateOutputFilterSensitiveLog)
    .ser(se_StartEdgeConfigurationUpdateCommand)
    .de(de_StartEdgeConfigurationUpdateCommand)
    .build() {
}
